config/routes.rb
Rails.application.routes.draw do

  require 'sidekiq/web'
  mount Sidekiq::Web => '/sidekiq'

  devise_for :admins
  devise_for :users

  mount RailsAdmin::Engine => '/', as: 'rails_admin'

  root 'dashboard#index'

  resources :trips, only: [:index, :show]

  namespace :api do
    namespace :v1 do

      resources :trips, except: [:new, :edit, :update, :destroy]

      put '/trips/:id', to: 'trips#finish', as: :finish

      resources :stations, only: [:index]
      resources :bikes, only: [:index]

      post 'login', to: 'users#login', as: :login
      post 'logout', to: 'users#logout', as: :logout
    end
  end
end

app/models/admin.rb
class Admin < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/bike.rb
class Bike < ApplicationRecord

  validates_presence_of :code, :station_id

  has_and_belongs_to_many :users, through: :trips
  belongs_to :station
  has_one :bike_maintenance

  scope :available, -> { where(available: true) }
end

app/models/bike_maintenance.rb
class BikeMaintenance < ApplicationRecord

  validates_presence_of :reason, :bike_id

  has_many :bikes
end

app/models/station.rb
class Station < ApplicationRecord

  validates_presence_of :name, :latitude, :longitude

  has_many :trips
  has_many :bikes
end

app/models/trip.rb
class Trip < ApplicationRecord

  validates_presence_of :bike_id, :user_id, :started_at, :origin_station

  belongs_to :bike
  belongs_to :user

  def load_origin_station
    Station.find(origin_station)
  end

  def load_destination_station
    Station.find(destination_station)
  end
end

app/models/user.rb
class User < ApplicationRecord

  acts_as_token_authenticatable

  validates_presence_of :name

  has_and_belongs_to_many :bikes, through: :trips

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/api/v1/application_controller.rb
class Api::V1::ApplicationController < ActionController::Base

  acts_as_token_authentication_handler_for User, except: [:login]

end

app/controllers/api/v1/bikes_controller.rb
class Api::V1::BikesController < Api::V1::ApplicationController

  def index
    bikes = BikeRepository.all

    render json: bikes, status: :ok, each_serializer: BikeSerializer
  end
end

app/controllers/api/v1/stations_controller.rb
class Api::V1::StationsController < Api::V1::ApplicationController

  def index
    stations = StationRepository.all

    render json: stations, status: :ok, each_serializer: StationSerializer
  end
end

app/controllers/api/v1/trips_controller.rb
class Api::V1::TripsController < Api::V1::ApplicationController

  before_action :trip_params, only: [:create, :update]

  def index
    trips = TripRepository.all

    render json: trips, status: :ok, each_serializer: TripSerializer
  end

  def show
    begin
      load_trip

      render json: @trip, status: :ok

    rescue ActiveRecord::RecordNotFound

      render json: { message: I18n.t('activerecord.errors.messages.record_not_found', model_type: I18n.t('trips.label.trip')) },
             status: :not_found
    end
  end

  def create
    begin
      trip_created = CreateTripFacade.create!(params['trip']['bike_id'],
                                              params['trip']['user_id'],
                                              params['trip']['origin_station'])

      render json: trip_created, status: :created

    rescue RentBikesUnderMaintenanceError, RentedBikeError, BikeNotAvailableError => error

      render json: { message: error.message },
             status: :unprocessable_entity

    rescue ActiveRecord::RecordNotFound

      render json: { message: I18n.t('activerecord.errors.messages.record_not_found', model_type: I18n.t('trips.label.trip')) },
             status: :not_found

    rescue ActiveRecord::RecordInvalid, ActiveRecord::InvalidForeignKey

      render json: { message: I18n.t('activerecord.errors.messages.invalid_fields') },
             status: :unprocessable_entity
    end
  end

  def finish
    begin
      load_trip

      finish_trip = FinishTripFacade.new(@trip.load_origin_station, params['trip']['destination_station'])

      finish_trip.finish!(@trip)

      render json: @trip, status: :ok

    rescue FinishAtOriginStationError => error

      render json: { message: error.message },
             status: :unprocessable_entity

    rescue ActiveRecord::RecordNotFound

      render json: { message: I18n.t('activerecord.errors.messages.record_not_found', model_type: I18n.t('trips.label.trip')) },
             status: :not_found
    end
  end

  private

    include TripConcern
end

app/controllers/api/v1/users_controller.rb
class Api::V1::UsersController < Api::V1::ApplicationController

  skip_before_action :verify_authenticity_token, only: [:login]

  def login
    @user = UserRepository.find_by_email(params['user']['email'])

    if @user&.valid_password?(params['user']['password'])

      sign_in @user

      render json: @user, status: :ok
    else
      head :unauthorized
    end
  end

  def logout
    current_user.authentication_token = nil

    current_user.save!

    render json: { message: I18n.t('devise.sessions.signed_out') }, status: :ok
  end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :authenticate_admin!
end

app/controllers/concerns/trip_concern.rb
module TripConcern

  def load_trip
    @trip = TripRepository.find_by_id(params['id'])
  end

  def trip_params
    params.require(:trip).permit(:user_id, :bike_id, :origin_station, :destination_station)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/trips_helper.rb
module TripsHelper
end

app/views/home/index.html.erb
<p id="notice"><%= notice %></p>
<p class="alert"><%= alert %></p>

<h1>Bem vindo</h1>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>BikeTipoVc</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= favicon_link_tag asset_path('bike_tipo_vc_logo.png') %>

    <script src="https://code.jquery.com/jquery-3.4.1.min.js" integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo=" crossorigin="anonymous"></script>

    <%= stylesheet_pack_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>

    <link href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet" integrity="sha384-wvfXpqpZZVQGK6TAh5PVlGOfQNHSoD2xbE+QkPxCAFlNEevoEH3Sl0sibVcOQVnN" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/animate.css/3.7.2/animate.min.css" integrity="sha256-PHcOkPmOshsMBC+vtJdVr5Mwb7r0LkSVJPlPrp/IMpU=" crossorigin="anonymous" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/hamburgers/1.1.3/hamburgers.min.css" integrity="sha256-JPv5igMSqm2ztJxtjiup0q6NMWu7L3MbMn9FqyPgfdo=" crossorigin="anonymous" />
    <link rel="stylesheet" href="https://raw.githubusercontent.com/daneden/animate.css/master/animate.css" crossorigin="anonymous" />
    <link href="https://cdn.jsdelivr.net/npm/select2@4.0.13/dist/css/select2.min.css" rel="stylesheet" />
    <link href="https://fonts.googleapis.com/css?family=Poppins:400,500,700&display=swap" rel="stylesheet">
  </head>

  <body>

    <%= yield %>

    <script src="https://cdn.jsdelivr.net/npm/animsition@4.0.2/dist/js/animsition.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/select2@4.0.13/dist/js/select2.min.js"></script>
  </body>
</html>

app/views/trips/index.html.erb
<div class="limiter">

  <p id="notice"><%= notice %></p>

  <span class="login100-form-title p-b-70 text-left">
      Trips
  </span>

  <div class="container-login100">

    <div class="wrap-login100 p-t-85 p-b-20">

      <span class="login100-form-avatar">
        <%= image_tag('bike_tipo_vc_logo.png') %>
      </span>

      <table>
        <thead>
        <tr>
          <th colspan="3"></th>
        </tr>
        </thead>

        <tbody>
        <% @trips.each do |trip| %>
          <tr>
            <td><%= link_to 'Show', trip %></td>
          </tr>
        <% end %>
        </tbody>
      </table>

    </div>

  </div>

</div>

app/views/trips/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Back', trips_path %>